const fs = require('fs-extra');
const path = require('path');
const autoprefixer = require('autoprefixer');
const postcss = require('postcss');
const postcssAtImport = require('postcss-import');
const postcssUrl = require('postcss-url');

const root = path.resolve(__dirname, '../../');
const css = path.resolve(root, 'src/index.css');
const build = path.resolve(root, '.build/index.css');

fs.readFile(css, (err, data) => {
  if (err) throw err;
  postcss([postcssAtImport, postcssUrl, autoprefixer])
    .process(data.toString(), { from: css, to: build })
    .then((result) => {
      fs.outputFileSync(build, result.css, () => true);
    });
});
