export default {
  title: 'Website Experience Subsystem/Foundation/Typography',
  parameters: {
    docs: {
      source: {
        type: 'auto',
      },
    },
  },
};

const paraStyle = 'style="margin:25px 0 5px 0"';
const codeStyle = 'style="padding: 8px;background: #f3f3f3;color: #181818;display: block;width:50%"';
const Template = () =>
  `<div>
  <h1 type-style="display-1" ${paraStyle}>Title display-1</h1>
  <code ${codeStyle}>&lt;h1 type-style="display-1"&gt;Title display-1&lt;/h1&gt;</code>
  
  <h2 type-style="display-2" ${paraStyle}>Title display-2</h2>
  <code ${codeStyle}>&lt;h2 type-style="display-2"&gt;Title display-2&lt;/h2&gt;</code>
  
  <h3 type-style="display-3" ${paraStyle}>Title display-3</h3>
  <code ${codeStyle}>&lt;h3 type-style="display-3"&gt;Title display-3&lt;/h3&gt;</code>
  
  <h4 type-style="display-4" ${paraStyle}>Title display-4</h4>
  <code ${codeStyle}>&lt;h4 type-style="display-4"&gt;Title display-4&lt;/h4&gt;</code>
  
  <h5 type-style="display-5" ${paraStyle}>Title display-5</h5>
  <code ${codeStyle}>&lt;h5 type-style="display-5"&gt;Title display-5&lt;/h5&gt;</code>
  
  <h6 type-style="display-6" ${paraStyle}>Title display-6</h6>
  <code ${codeStyle}>&lt;h6 type-style="display-6"&gt;Title display-6&lt;/h6&gt;</code>
  
  <h6 type-style="display-7" ${paraStyle}>Title display-7</h6>
  <code ${codeStyle}>&lt;h6 type-style="display-7"&gt;Title display-7&lt;/h6&gt;</code>
  
  <h6 type-style="display-8" ${paraStyle}>Title display-8</h6>
  <code ${codeStyle}>&lt;h6 type-style="display-8"&gt;Title display-8&lt;/h6&gt;</code>

  <p type-style="body-1" ${paraStyle}>Text body-1</p>
  <code ${codeStyle}>&lt;p type-style="body-1"&gt;Text body-1&lt;/p&gt;</code>

  <p type-style="body-2" ${paraStyle}>Text body-2</p>
  <code ${codeStyle}>&lt;p type-style="body-2"&gt;Text body-2&lt;/p&gt;</code>

  <p type-style="body-3" ${paraStyle}>Text body-3</p>
  <code ${codeStyle}>&lt;p type-style="body-3"&gt;Text body-3&lt;/p&gt;</code>
  
  <p type-style="eyebrow" ${paraStyle}>Text eyebrow</p>
  <code ${codeStyle}>&lt;p type-style="eyebrow"&gt;Text eyebrow&lt;/p&gt;</code>
  
  <p type-style="caption" ${paraStyle}>Text caption</p>
  <code ${codeStyle}>&lt;p type-style="caption"&gt;Text caption&lt;/p&gt;</code>

  <div type-style="body-1"><p type-style="code" ${paraStyle}>Text body-1 code</p></div>
  <code ${codeStyle}>
    &lt;div type-style="body-1"&gt;&lt;p type-style="code"&gt;Text body-1 code&lt;/p&gt;&lt;/div&gt;
  </code>
  
  <div type-style="body-2"><p type-style="code" ${paraStyle}>Text body-2 code</p></div>
  <code ${codeStyle}>
    &lt;div type-style="body-2"&gt;&lt;p type-style="code"&gt;Text body-2 code&lt;/p&gt;&lt;/div&gt;
  </code>

  <div type-style="body-3"><p type-style="code" ${paraStyle}>Text body-3 code</p></div>
  <code ${codeStyle}>
    &lt;div type-style="body-3"&gt;&lt;p type-style="code"&gt;Text body-3 code&lt;/p&gt;&lt;/div&gt;
  </code>

  <div type-style="caption"><p type-style="code" ${paraStyle}>Text caption code</p></div>
  <code ${codeStyle}>
    &lt;div type-style="caption"&gt;&lt;p type-style="code"&gt;Text caption code&lt;/p&gt;&lt;/div&gt;
  </code>

  <p type-style="body-1" ${paraStyle}><a href="#">body-1 link</a></p>
  <code ${codeStyle}>&lt;p type-style="body-1"&gt;&lt;a href="#"&gt;body-1 link&lt;/a&gt;&lt;/p&gt;</code>

  <p type-style="body-2" ${paraStyle}><a href="#">body-2 link</a></p>
  <code ${codeStyle}>&lt;p type-style="body-2"&gt;&lt;a href="#"&gt;body-2 link&lt;/a&gt;&lt;/p&gt;</code>

  <p type-style="body-3" ${paraStyle}><a href="#">body-3 link</a></p>
  <code ${codeStyle}>&lt;p type-style="body-3"&gt;&lt;a href="#"&gt;body-3 link&lt;/a&gt;&lt;/p&gt;</code>

  </div>`;
export const All = Template.bind({});

const HeadingTemplate = (args) =>
  `<p type-style="${args.typeStyle}">The quick brown fox jumps over the lazy dog</p>`;
export const Heading = HeadingTemplate.bind({});
Heading.args = {
  typeStyle: 'display-1',
};
Heading.argTypes = {
  typeStyle: {
    name: 'type-style',
    control: {
      type: 'select',
      options: [
        'display-1',
        'display-2',
        'display-3',
        'display-4',
        'display-5',
        'display-6',
        'display-7',
        'display-8',
      ],
    },
    defaultValue: 'display-1',
    description: 'Heading type style',
    table: {
      type: { summary: 'string' },
      defaultValue: { summary: 'display-1' },
    },
  },
};

const HeadingLinkTemplate = (args) =>
  `<a type-style="${args.typeStyle}" href="#">The quick brown fox jumps over the lazy dog</a>`;
export const HeadingLink = HeadingLinkTemplate.bind({});
HeadingLink.args = {
  typeStyle: 'display-1',
};
HeadingLink.argTypes = {
  typeStyle: {
    name: 'type-style',
    control: {
      type: 'select',
      options: [
        'display-1',
        'display-2',
        'display-3',
        'display-4',
        'display-5',
        'display-6',
        'display-7',
        'display-8',
      ],
    },
    defaultValue: 'display-1',
    description: 'Heading type style',
    table: {
      type: { summary: 'string' },
      defaultValue: { summary: 'display-1' },
    },
  },
};

const BodyTemplate = (args) =>
  `<p type-style="${args.typeStyle}">A CRM solution helps you focus on your organization’s relationships with individual people — including customers, service users, colleagues, or suppliers — throughout your lifecycle with them, including finding new customers, winning their business, and providing support and additional services throughout the relationship.</p>`;
export const Body = BodyTemplate.bind({});
Body.args = {
  typeStyle: 'body-1',
};
Body.argTypes = {
  typeStyle: {
    name: 'type-style',
    control: {
      type: 'select',
      options: ['body-1', 'body-2', 'body-3'],
    },
  },
};

const BodyLinkTemplate = (args) => `<p type-style="${args.typeStyle}"><a href="#">Body link</a></p>`;
export const BodyLink = BodyLinkTemplate.bind({});
BodyLink.args = {
  typeStyle: 'body-1',
};
BodyLink.argTypes = {
  typeStyle: {
    name: 'type-style',
    control: {
      type: 'select',
      options: ['body-1', 'body-2', 'body-3', 'caption'],
    },
  },
};

const EyebrowTemplate = () => `<p type-style="eyebrow">The quick brown fox jumps over the lazy dog</p>`;
export const Eyebrow = EyebrowTemplate.bind({});
Eyebrow.args = {
  typeStyle: 'eyebrow',
};
Eyebrow.argTypes = {
  typeStyle: {
    name: 'type-style',
    control: {
      type: 'select',
      options: ['eyebrow'],
    },
  },
};

const CaptionTemplate = () =>
  `<p type-style="caption">A CRM solution helps you focus on your organization’s relationships with individual people — including customers, service users, colleagues, or suppliers — throughout your lifecycle with them, including finding new customers, winning their business, and providing support and additional services throughout the relationship.</p>`;
export const Caption = CaptionTemplate.bind({});
Caption.args = {
  typeStyle: 'caption',
};
Caption.argTypes = {
  typeStyle: {
    name: 'type-style',
    control: {
      type: 'select',
      options: ['caption'],
    },
  },
};

const CodeTemplate = (args) =>
  `<div type-style="${args.typeStyle}"><p type-style="code">curl -X POST -H "Authorization: Bearer <TOKEN>" -H "Cache-Control: no-cache" -H "Content-Type: multipart/form-data"</p></div>`;
export const Code = CodeTemplate.bind({});
Code.args = {
  typeStyle: 'body-1',
};
Code.argTypes = {
  typeStyle: {
    name: 'type-style',
    control: {
      type: 'select',
      options: ['body-1', 'body-2', 'body-3', 'caption'],
    },
  },
};
